using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_permission_function_map_view")]
    public class SecurityPermissionFunctionMapViewEntity : ViewEntityBase
    {

    public SecurityPermissionFunctionMapViewEntity() 
    {
    }

    [Column("permission_name")]
    public string PermissionName  { get; set; }
    [Column("function_name")]
    public string FunctionName  { get; set; }
    [Column("page_name")]
    public string? PageName  { get; set; }

    public const string PERMISSION_NAME = "PermissionName";
    public const string FUNCTION_NAME = "FunctionName";
    public const string PAGE_NAME = "PageName";

    public const string DB_NAME_SECURITY_PERMISSION_FUNCTION_MAP_VIEW = "security_permission_function_map_view";
    public const string DB_NAME_FIELDS="permission_name,function_name,page_name";

    public const string DB_PERMISSION_NAME = "permission_name";
    public const string DB_FUNCTION_NAME = "function_name";
    public const string DB_PAGE_NAME = "page_name";


    public static SecurityPermissionFunctionMapViewEntity GetInstance()
    {
        return new SecurityPermissionFunctionMapViewEntity();
    }

    public virtual void CopyFrom(SecurityPermissionFunctionMapViewEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityPermissionFunctionMapViewEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.PermissionName =  source.PermissionName;
        this.FunctionName =  source.FunctionName;
        this.PageName =  source.PageName;

        if (includeSystemFields)
        {
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_PERMISSION_FUNCTION_MAP_VIEW}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_PERMISSION_FUNCTION_MAP_VIEW}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
		
        if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_PERMISSION_NAME ;  		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_PERMISSION_FUNCTION_MAP_VIEW}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityPermissionFunctionMapViewEntity Clone()
    {
        SecurityPermissionFunctionMapViewEntity result = new SecurityPermissionFunctionMapViewEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
